import 'package:appier_flutter/appier_flutter.dart';
import 'package:flutter/material.dart';

const appUniversalLink = 'universal-link';

class EventWidget extends StatefulWidget {
  const EventWidget({Key? key}) : super(key: key);

  @override
  _EventWidgetState createState() => _EventWidgetState();
}

class _EventWidgetState extends State<EventWidget> {
  @override
  void initState() {
    super.initState();
  }

  @override
  void dispose() {
    super.dispose();
  }

  @override
  Widget build(BuildContext context) {
    return Center(
      child: ListView(
        padding: EdgeInsets.all(8),
        children: <Widget>[
          SizedBox(
            height: 44,
            child: ElevatedButton(
              style: ElevatedButton.styleFrom(
                primary: Colors.teal[100],
                onPrimary: Colors.black,
              ),
              onPressed: AppierFlutter.flush,
              child: Text('Flush()'),
            ),
          ),
          SizedBox(
            height: 44,
            child: ElevatedButton(
              style: ElevatedButton.styleFrom(
                primary: Colors.teal[200],
                onPrimary: Colors.black,
              ),
              onPressed: () {
                for (var i = 0; i < 100; i++) {
                  AppierFlutter.logEvent('test_100_events');
                }
              },
              child: Text('100 Events'),
            ),
          ),
          SizedBox(
            height: 44,
            child: ElevatedButton(
              style: ElevatedButton.styleFrom(
                primary: Colors.teal[100],
                onPrimary: Colors.black,
              ),
              onPressed: () {
                AppierFlutter.logEvent(
                  'product_viewed',
                  parameters: <String, dynamic>{
                    'param1': 2,
                    'param2': null,
                    'param3': 'appier',
                    // Regression test cases for https://appier.atlassian.net/browse/MT-1036
                    'NULL': 'aiqua',
                    'null': 'aiqua',
                    'Null': 'aiqua',
                  },
                );
              },
              child: Text('Log Event - product_viewed'),
            ),
          ),
          SizedBox(
            height: 44,
            child: ElevatedButton(
              style: ElevatedButton.styleFrom(
                primary: Colors.teal[200],
                onPrimary: Colors.black,
              ),
              onPressed: () {
                AppierFlutter.logEvent(
                  'product_add_to_cart',
                  parameters: <String, dynamic>{
                    'param1': 2,
                    'param2': null,
                    'param3': 'appier',
                  },
                );
              },
              child: Text('Log Event - product_add_to_cart'),
            ),
          ),
          SizedBox(
            height: 44,
            child: ElevatedButton(
              style: ElevatedButton.styleFrom(
                primary: Colors.teal[100],
                onPrimary: Colors.black,
              ),
              onPressed: () {
                AppierFlutter.logEvent(
                  'product_purchased',
                  parameters: <String, dynamic>{
                    'param1': 2,
                    'param2': null,
                    'param3': 'appier',
                  },
                  vts: 100,
                  vtsCurr: 'USD',
                );
              },
              child: Text('Log Event - product_purchased'),
            ),
          ),
          SizedBox(
            height: 44,
            child: ElevatedButton(
              style: ElevatedButton.styleFrom(
                primary: Colors.teal[200],
                onPrimary: Colors.black,
              ),
              onPressed: () {
                AppierFlutter.setUniversalLinkDomains([]);
                AppierFlutter.setUniversalLinkDomains([appUniversalLink]);
              },
              child: Text('Set UniversalLinkDomains - iOS only'),
            ),
          ),
          SizedBox(
            height: 44,
            child: ElevatedButton(
              style: ElevatedButton.styleFrom(
                primary: Colors.teal[100],
                onPrimary: Colors.black,
              ),
              onPressed: () {
                AppierFlutter.setUserId('');
                AppierFlutter.setUserId('flutter-test11234');
                AppierFlutter.setName('ススキ　イチロ');
                AppierFlutter.setFirstName('flutter-first');
                AppierFlutter.setLastName('flutter-last');
                AppierFlutter.setCity('Tokyo');
                AppierFlutter.setEmail('mobile@appier.com');
                AppierFlutter.setPhoneNumber('+886-111-222-333');
                AppierFlutter.setDayOfBirth(30);
                AppierFlutter.setMonthOfBirth(3);
                AppierFlutter.setYearOfBirth(2021);
                AppierFlutter.setCustomKey('test-boolean', false);
                AppierFlutter.setCustomKey('test-String', 'yoooooo123');
                AppierFlutter.setCustomKey('test-number', 111234111.2222222);
                AppierFlutter.setCustomKey('test-null', null);
                AppierFlutter.setCustomKey('test-object',
                    {'test-string': 'ya', 'test-boolean': false});
              },
              child: Text('Set Profile'),
            ),
          ),
        ],
      ),
    );
  }
}
