import 'dart:convert';

import 'package:appier_flutter/appier_flutter.dart';
import 'package:flutter/material.dart';

class RecommendationWidget extends StatefulWidget {
  const RecommendationWidget({Key? key}) : super(key: key);

  @override
  _RecommendationWidgetState createState() => _RecommendationWidgetState();
}

class _RecommendationWidgetState extends State<RecommendationWidget> {
  @override
  void initState() {
    super.initState();
  }

  @override
  void dispose() {
    super.dispose();
  }

  @override
  Widget build(BuildContext context) {
    return Center(
      child: ListView(
        padding: EdgeInsets.all(8),
        children: <Widget>[
          SizedBox(
            height: 44,
            child: ElevatedButton(
              style: ElevatedButton.styleFrom(
                primary: Colors.teal[100],
                onPrimary: Colors.black,
              ),
              onPressed: () {
                AppierFlutter.getRecommendation(
                  'Aj2MMx5KHzPau2pv4aQ26i',
                  productId: 'TEST_SKU_1',
                  parameters: <String, dynamic>{
                    'num': 5,
                    'filter': <String, dynamic>{
                      'rules': [
                        <String, dynamic>{
                          'key': 'category',
                          'op': 'in',
                          'val': '3C > Mobile > Nokia'
                        }
                      ]
                    },
                  },
                ).then((data) {
                  print('Recommendation items: $data');
                  var message = 'Failed';
                  if (data != null) {
                    message = jsonEncode(data);
                  }
                  _showMyDialog('Get Recommendation', message);
                }).catchError((dynamic error) {
                  print('Recommendation error: ${error as String}');
                  _showMyDialog('Error', error);
                });
              },
              child: Text('Get Recommendation'),
            ),
          ),
          SizedBox(
            height: 44,
            child: ElevatedButton(
              style: ElevatedButton.styleFrom(
                primary: Colors.teal[200],
                onPrimary: Colors.black,
              ),
              onPressed: () {
                AppierFlutter.logRecommendationClicked(
                    'Aj2MMx5KHzPau2pv4aQ26i', 12, 'TEST_SKU_1', 'recId');
                _showMyDialog('Log Recommendation Clicked',
                    'Log event recommendation_clicked.');
              },
              child: Text('Log Recommendation Clicked'),
            ),
          ),
        ],
      ),
    );
  }

  Future<void> _showMyDialog(String title, String content) async {
    return showDialog<void>(
      context: context,
      barrierDismissible: false, // user must tap button!
      builder: (context) {
        return AlertDialog(
          title: Text(title),
          content: SingleChildScrollView(
            child: Text(content),
          ),
          actions: <Widget>[
            TextButton(
              onPressed: () {
                Navigator.of(context).pop();
              },
              child: Text('OK'),
            ),
          ],
        );
      },
    );
  }
}
